package com.sun.rowset.internal;

import org.xml.sax.SAXParseException;
import javax.sql.rowset.RowSetMetaDataImpl;
import java.sql.Timestamp;
import java.sql.Time;
import java.sql.Date;
import java.math.BigDecimal;
import java.util.Iterator;
import java.text.MessageFormat;
import sun.reflect.misc.ReflectUtil;
import java.sql.SQLException;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import java.io.IOException;
import javax.sql.RowSet;
import com.sun.rowset.JdbcRowSetResourceBundle;
import javax.sql.RowSetMetaData;
import com.sun.rowset.WebRowSetImpl;
import java.util.Vector;
import java.util.HashMap;
import org.xml.sax.helpers.DefaultHandler;

public class XmlReaderContentHandler extends DefaultHandler
{
    private HashMap<String, Integer> propMap;
    private HashMap<String, Integer> colDefMap;
    private HashMap<String, Integer> dataMap;
    private HashMap<String, Class<?>> typeMap;
    private Vector<Object[]> updates;
    private Vector<String> keyCols;
    private String columnValue;
    private String propertyValue;
    private String metaDataValue;
    private int tag;
    private int state;
    private WebRowSetImpl rs;
    private boolean nullVal;
    private boolean emptyStringVal;
    private RowSetMetaData md;
    private int idx;
    private String lastval;
    private String Key_map;
    private String Value_map;
    private String tempStr;
    private String tempUpdate;
    private String tempCommand;
    private Object[] upd;
    private String[] properties;
    private static final int CommandTag = 0;
    private static final int ConcurrencyTag = 1;
    private static final int DatasourceTag = 2;
    private static final int EscapeProcessingTag = 3;
    private static final int FetchDirectionTag = 4;
    private static final int FetchSizeTag = 5;
    private static final int IsolationLevelTag = 6;
    private static final int KeycolsTag = 7;
    private static final int MapTag = 8;
    private static final int MaxFieldSizeTag = 9;
    private static final int MaxRowsTag = 10;
    private static final int QueryTimeoutTag = 11;
    private static final int ReadOnlyTag = 12;
    private static final int RowsetTypeTag = 13;
    private static final int ShowDeletedTag = 14;
    private static final int TableNameTag = 15;
    private static final int UrlTag = 16;
    private static final int PropNullTag = 17;
    private static final int PropColumnTag = 18;
    private static final int PropTypeTag = 19;
    private static final int PropClassTag = 20;
    private static final int SyncProviderTag = 21;
    private static final int SyncProviderNameTag = 22;
    private static final int SyncProviderVendorTag = 23;
    private static final int SyncProviderVersionTag = 24;
    private static final int SyncProviderGradeTag = 25;
    private static final int DataSourceLock = 26;
    private String[] colDef;
    private static final int ColumnCountTag = 0;
    private static final int ColumnDefinitionTag = 1;
    private static final int ColumnIndexTag = 2;
    private static final int AutoIncrementTag = 3;
    private static final int CaseSensitiveTag = 4;
    private static final int CurrencyTag = 5;
    private static final int NullableTag = 6;
    private static final int SignedTag = 7;
    private static final int SearchableTag = 8;
    private static final int ColumnDisplaySizeTag = 9;
    private static final int ColumnLabelTag = 10;
    private static final int ColumnNameTag = 11;
    private static final int SchemaNameTag = 12;
    private static final int ColumnPrecisionTag = 13;
    private static final int ColumnScaleTag = 14;
    private static final int MetaTableNameTag = 15;
    private static final int CatalogNameTag = 16;
    private static final int ColumnTypeTag = 17;
    private static final int ColumnTypeNameTag = 18;
    private static final int MetaNullTag = 19;
    private String[] data;
    private static final int RowTag = 0;
    private static final int ColTag = 1;
    private static final int InsTag = 2;
    private static final int DelTag = 3;
    private static final int InsDelTag = 4;
    private static final int UpdTag = 5;
    private static final int NullTag = 6;
    private static final int EmptyStringTag = 7;
    private static final int INITIAL = 0;
    private static final int PROPERTIES = 1;
    private static final int METADATA = 2;
    private static final int DATA = 3;
    private JdbcRowSetResourceBundle resBundle;
    
    public XmlReaderContentHandler(RowSet set) {
        this.properties = new String[] { "command", "concurrency", "datasource", "escape-processing", "fetch-direction", "fetch-size", "isolation-level", "key-columns", "map", "max-field-size", "max-rows", "query-timeout", "read-only", "rowset-type", "show-deleted", "table-name", "url", "null", "column", "type", "class", "sync-provider", "sync-provider-name", "sync-provider-vendor", "sync-provider-version", "sync-provider-grade", "data-source-lock" };
        this.colDef = new String[] { "column-count", "column-definition", "column-index", "auto-increment", "case-sensitive", "currency", "nullable", "signed", "searchable", "column-display-size", "column-label", "column-name", "schema-name", "column-precision", "column-scale", "table-name", "catalog-name", "column-type", "column-type-name", "null" };
        this.data = new String[] { "currentRow", "columnValue", "insertRow", "deleteRow", "insdel", "updateRow", "null", "emptyString" };
        this.rs = (WebRowSetImpl)set;
        this.initMaps();
        this.updates = new Vector();
        this.columnValue = "";
        this.propertyValue = "";
        this.metaDataValue = "";
        this.nullVal = false;
        this.idx = 0;
        this.tempStr = "";
        this.tempUpdate = "";
        this.tempCommand = "";
        try {
            this.resBundle = JdbcRowSetResourceBundle.getJdbcRowSetResourceBundle();
        }
        catch (IOException cause) {
            throw new RuntimeException(cause);
        }
    }
    
    private void initMaps() {
        this.propMap = new HashMap();
        for (int length = this.properties.length, i = 0; i < length; ++i) {
            this.propMap.put(this.properties[i], Integer.valueOf(i));
        }
        this.colDefMap = new HashMap();
        for (int length2 = this.colDef.length, j = 0; j < length2; ++j) {
            this.colDefMap.put(this.colDef[j], Integer.valueOf(j));
        }
        this.dataMap = new HashMap();
        for (int length3 = this.data.length, k = 0; k < length3; ++k) {
            this.dataMap.put(this.data[k], Integer.valueOf(k));
        }
        this.typeMap = new HashMap();
    }
    
    @Override
    public void startDocument() throws SAXException {
    }
    
    @Override
    public void endDocument() throws SAXException {
    }
    
    @Override
    public void startElement(String s, String s2, String s3, Attributes attributes) throws SAXException {
        switch (this.getState()) {
            case 1: {
                this.tempCommand = "";
                int intValue = (int)this.propMap.get(s2);
                if (intValue == 17) {
                    this.setNullValue(true);
                    break;
                }
                this.setTag(intValue);
                break;
            }
            case 2: {
                int intValue2 = (int)this.colDefMap.get(s2);
                if (intValue2 == 19) {
                    this.setNullValue(true);
                    break;
                }
                this.setTag(intValue2);
                break;
            }
            case 3: {
                this.tempStr = "";
                this.tempUpdate = "";
                int intValue3;
                if (this.dataMap.get(s2) == null) {
                    intValue3 = 6;
                }
                else if ((int)this.dataMap.get(s2) == 7) {
                    intValue3 = 7;
                }
                else {
                    intValue3 = (int)this.dataMap.get(s2);
                }
                if (intValue3 == 6) {
                    this.setNullValue(true);
                    break;
                }
                if (intValue3 == 7) {
                    this.setEmptyStringValue(true);
                    break;
                }
                this.setTag(intValue3);
                if (intValue3 == 0 || intValue3 == 3 || intValue3 == 2) {
                    this.idx = 0;
                    try {
                        this.rs.moveToInsertRow();
                        break;
                    }
                    catch (SQLException ex) {
                        break;
                    }
                    break;
                }
                break;
            }
            default: {
                this.setState(s2);
                break;
            }
        }
    }
    
    @Override
    public void endElement(String s, String key, String s2) throws SAXException {
        switch (this.getState()) {
            case 1: {
                if (key.equals("properties")) {
                    this.state = 0;
                    break;
                }
                try {
                    switch ((int)this.propMap.get(key)) {
                        case 7: {
                            if (this.keyCols != null) {
                                int[] keyColumns = new int[this.keyCols.size()];
                                for (int i = 0; i < keyColumns.length; ++i) {
                                    keyColumns[i] = Integer.parseInt((String)this.keyCols.elementAt(i));
                                }
                                this.rs.setKeyColumns(keyColumns);
                                break;
                            }
                            break;
                        }
                        case 20: {
                            try {
                                this.typeMap.put(this.Key_map, ReflectUtil.forName(this.Value_map));
                                break;
                            }
                            catch (ClassNotFoundException ex) {
                                throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errmap").toString(), new Object[] { ex.getMessage() }));
                            }
                        }
                        case 8: {
                            this.rs.setTypeMap(this.typeMap);
                            break;
                        }
                    }
                    if (this.getNullValue()) {
                        this.setPropertyValue(null);
                        this.setNullValue(false);
                    }
                    else {
                        this.setPropertyValue(this.propertyValue);
                    }
                }
                catch (SQLException ex2) {
                    throw new SAXException(ex2.getMessage());
                }
                this.propertyValue = "";
                this.setTag(-1);
                break;
            }
            case 2: {
                if (key.equals("metadata")) {
                    try {
                        this.rs.setMetaData(this.md);
                        this.state = 0;
                    }
                    catch (SQLException ex4) {
                        throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errmetadata").toString(), new Object[] { ex4.getMessage() }));
                    }
                }
                else {
                    try {
                        if (this.getNullValue()) {
                            this.setMetaDataValue(null);
                            this.setNullValue(false);
                        }
                        else {
                            this.setMetaDataValue(this.metaDataValue);
                        }
                    }
                    catch (SQLException ex3) {
                        throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errmetadata").toString(), new Object[] { ex3.getMessage() }));
                    }
                    this.metaDataValue = "";
                }
                this.setTag(-1);
                break;
            }
            case 3: {
                if (key.equals("data")) {
                    this.state = 0;
                    return;
                }
                int intValue;
                if (this.dataMap.get(key) == null) {
                    intValue = 6;
                }
                else {
                    intValue = (int)this.dataMap.get(key);
                }
                switch (intValue) {
                    case 1: {
                        try {
                            ++this.idx;
                            if (this.getNullValue()) {
                                this.insertValue(null);
                                this.setNullValue(false);
                            }
                            else {
                                this.insertValue(this.tempStr);
                            }
                            this.columnValue = "";
                            break;
                        }
                        catch (SQLException ex5) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errinsertval").toString(), new Object[] { ex5.getMessage() }));
                        }
                    }
                    case 0: {
                        try {
                            this.rs.insertRow();
                            this.rs.moveToCurrentRow();
                            this.rs.next();
                            this.rs.setOriginalRow();
                            this.applyUpdates();
                            break;
                        }
                        catch (SQLException ex6) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errconstr").toString(), new Object[] { ex6.getMessage() }));
                        }
                    }
                    case 3: {
                        try {
                            this.rs.insertRow();
                            this.rs.moveToCurrentRow();
                            this.rs.next();
                            this.rs.setOriginalRow();
                            this.applyUpdates();
                            this.rs.deleteRow();
                            break;
                        }
                        catch (SQLException ex7) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errdel").toString(), new Object[] { ex7.getMessage() }));
                        }
                    }
                    case 2: {
                        try {
                            this.rs.insertRow();
                            this.rs.moveToCurrentRow();
                            this.rs.next();
                            this.applyUpdates();
                            break;
                        }
                        catch (SQLException ex8) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errinsert").toString(), new Object[] { ex8.getMessage() }));
                        }
                    }
                    case 4: {
                        try {
                            this.rs.insertRow();
                            this.rs.moveToCurrentRow();
                            this.rs.next();
                            this.rs.setOriginalRow();
                            this.applyUpdates();
                            break;
                        }
                        catch (SQLException ex9) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errinsdel").toString(), new Object[] { ex9.getMessage() }));
                        }
                    }
                    case 5: {
                        try {
                            if (this.getNullValue()) {
                                this.insertValue(null);
                                this.setNullValue(false);
                            }
                            else if (this.getEmptyStringValue()) {
                                this.insertValue("");
                                this.setEmptyStringValue(false);
                            }
                            else {
                                this.updates.add(this.upd);
                            }
                            break;
                        }
                        catch (SQLException ex10) {
                            throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errupdate").toString(), new Object[] { ex10.getMessage() }));
                        }
                    }
                }
                break;
            }
        }
    }
    
    private void applyUpdates() throws SAXException {
        if (this.updates.size() > 0) {
            try {
                Iterator<Object> iterator = this.updates.iterator();
                while (iterator.hasNext()) {
                    Object[] array = (Object[])(Object[])iterator.next();
                    this.idx = (int)array[0];
                    if (this.lastval.equals(array[1])) {
                        continue;
                    }
                    this.insertValue((String)(String)array[1]);
                }
                this.rs.updateRow();
            }
            catch (SQLException ex) {
                throw new SAXException(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.errupdrow").toString(), new Object[] { ex.getMessage() }));
            }
            this.updates.removeAllElements();
        }
    }
    
    @Override
    public void characters(char[] array, int n, int n2) throws SAXException {
        try {
            switch (this.getState()) {
                case 1: {
                    this.propertyValue = new String(array, n, n2);
                    this.tempCommand = this.tempCommand.concat(this.propertyValue);
                    this.propertyValue = this.tempCommand;
                    if (this.tag == 19) {
                        this.Key_map = this.propertyValue;
                        break;
                    }
                    if (this.tag == 20) {
                        this.Value_map = this.propertyValue;
                        break;
                    }
                    break;
                }
                case 2: {
                    if (this.tag == -1) {
                        break;
                    }
                    this.metaDataValue = new String(array, n, n2);
                    break;
                }
                case 3: {
                    this.setDataValue(array, n, n2);
                    break;
                }
            }
        }
        catch (SQLException ex) {
            throw new SAXException(this.resBundle.handleGetObject("xmlrch.chars").toString() + ex.getMessage());
        }
    }
    
    private void setState(String s) throws SAXException {
        if (s.equals("webRowSet")) {
            this.state = 0;
        }
        else if (s.equals("properties")) {
            if (this.state != 1) {
                this.state = 1;
            }
            else {
                this.state = 0;
            }
        }
        else if (s.equals("metadata")) {
            if (this.state != 2) {
                this.state = 2;
            }
            else {
                this.state = 0;
            }
        }
        else if (s.equals("data")) {
            if (this.state != 3) {
                this.state = 3;
            }
            else {
                this.state = 0;
            }
        }
    }
    
    private int getState() {
        return this.state;
    }
    
    private void setTag(int tag) {
        this.tag = tag;
    }
    
    private int getTag() {
        return this.tag;
    }
    
    private void setNullValue(boolean nullVal) {
        this.nullVal = nullVal;
    }
    
    private boolean getNullValue() {
        return this.nullVal;
    }
    
    private void setEmptyStringValue(boolean emptyStringVal) {
        this.emptyStringVal = emptyStringVal;
    }
    
    private boolean getEmptyStringValue() {
        return this.emptyStringVal;
    }
    
    private String getStringValue(String s) {
        return s;
    }
    
    private int getIntegerValue(String s) {
        return Integer.parseInt(s);
    }
    
    private boolean getBooleanValue(String s) {
        return (boolean)Boolean.valueOf(s);
    }
    
    private BigDecimal getBigDecimalValue(String val) {
        return new BigDecimal(val);
    }
    
    private byte getByteValue(String s) {
        return Byte.parseByte(s);
    }
    
    private short getShortValue(String s) {
        return Short.parseShort(s);
    }
    
    private long getLongValue(String s) {
        return Long.parseLong(s);
    }
    
    private float getFloatValue(String s) {
        return Float.parseFloat(s);
    }
    
    private double getDoubleValue(String s) {
        return Double.parseDouble(s);
    }
    
    private byte[] getBinaryValue(String s) {
        return s.getBytes();
    }
    
    private Date getDateValue(String s) {
        return new Date(this.getLongValue(s));
    }
    
    private Time getTimeValue(String s) {
        return new Time(this.getLongValue(s));
    }
    
    private Timestamp getTimestampValue(String s) {
        return new Timestamp(this.getLongValue(s));
    }
    
    private void setPropertyValue(String url) throws SQLException {
        int nullValue = this.getNullValue();
        switch (this.getTag()) {
            case 0: {
                if (!(nullValue == 0)) {
                    break;
                }
                this.rs.setCommand(url);
                break;
            }
            case 1: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setConcurrency(this.getIntegerValue(url));
                break;
            }
            case 2: {
                if (!(nullValue == 0)) {
                    this.rs.setDataSourceName(null);
                    break;
                }
                this.rs.setDataSourceName(url);
                break;
            }
            case 3: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setEscapeProcessing(this.getBooleanValue(url));
                break;
            }
            case 4: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setFetchDirection(this.getIntegerValue(url));
                break;
            }
            case 5: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setFetchSize(this.getIntegerValue(url));
                break;
            }
            case 6: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setTransactionIsolation(this.getIntegerValue(url));
                break;
            }
            case 7: {
                break;
            }
            case 18: {
                if (this.keyCols == null) {
                    this.keyCols = new Vector();
                }
                this.keyCols.add(url);
                break;
            }
            case 8: {
                break;
            }
            case 9: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setMaxFieldSize(this.getIntegerValue(url));
                break;
            }
            case 10: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setMaxRows(this.getIntegerValue(url));
                break;
            }
            case 11: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setQueryTimeout(this.getIntegerValue(url));
                break;
            }
            case 12: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setReadOnly(this.getBooleanValue(url));
                break;
            }
            case 13: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                String stringValue = this.getStringValue(url);
                int type = 0;
                if (stringValue.trim().equals("ResultSet.TYPE_SCROLL_INSENSITIVE")) {
                    type = 1004;
                }
                else if (stringValue.trim().equals("ResultSet.TYPE_SCROLL_SENSITIVE")) {
                    type = 1005;
                }
                else if (stringValue.trim().equals("ResultSet.TYPE_FORWARD_ONLY")) {
                    type = 1003;
                }
                this.rs.setType(type);
                break;
            }
            case 14: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue").toString());
                }
                this.rs.setShowDeleted(this.getBooleanValue(url));
                break;
            }
            case 15: {
                if (!(nullValue == 0)) {
                    break;
                }
                this.rs.setTableName(url);
                break;
            }
            case 16: {
                if (!(nullValue == 0)) {
                    this.rs.setUrl(null);
                    break;
                }
                this.rs.setUrl(url);
                break;
            }
            case 22: {
                if (!(nullValue == 0)) {
                    this.rs.setSyncProvider(null);
                    break;
                }
                this.rs.setSyncProvider(url.substring(0, url.indexOf("@") + 1));
                break;
            }
            case 23: {
                break;
            }
            case 24: {
                break;
            }
            case 25: {
                break;
            }
            case 26: {}
        }
    }
    
    private void setMetaDataValue(String s) throws SQLException {
        int nullValue = this.getNullValue();
        switch (this.getTag()) {
            case 0: {
                this.md = new RowSetMetaDataImpl();
                this.idx = 0;
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setColumnCount(this.getIntegerValue(s));
                break;
            }
            case 1: {
                break;
            }
            case 2: {
                ++this.idx;
                break;
            }
            case 3: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setAutoIncrement(this.idx, this.getBooleanValue(s));
                break;
            }
            case 4: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setCaseSensitive(this.idx, this.getBooleanValue(s));
                break;
            }
            case 5: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setCurrency(this.idx, this.getBooleanValue(s));
                break;
            }
            case 6: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setNullable(this.idx, this.getIntegerValue(s));
                break;
            }
            case 7: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setSigned(this.idx, this.getBooleanValue(s));
                break;
            }
            case 8: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setSearchable(this.idx, this.getBooleanValue(s));
                break;
            }
            case 9: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setColumnDisplaySize(this.idx, this.getIntegerValue(s));
                break;
            }
            case 10: {
                if (!(nullValue == 0)) {
                    this.md.setColumnLabel(this.idx, null);
                    break;
                }
                this.md.setColumnLabel(this.idx, s);
                break;
            }
            case 11: {
                if (!(nullValue == 0)) {
                    this.md.setColumnName(this.idx, null);
                    break;
                }
                this.md.setColumnName(this.idx, s);
                break;
            }
            case 12: {
                if (!(nullValue == 0)) {
                    this.md.setSchemaName(this.idx, null);
                    break;
                }
                this.md.setSchemaName(this.idx, s);
                break;
            }
            case 13: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setPrecision(this.idx, this.getIntegerValue(s));
                break;
            }
            case 14: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setScale(this.idx, this.getIntegerValue(s));
                break;
            }
            case 15: {
                if (!(nullValue == 0)) {
                    this.md.setTableName(this.idx, null);
                    break;
                }
                this.md.setTableName(this.idx, s);
                break;
            }
            case 16: {
                if (!(nullValue == 0)) {
                    this.md.setCatalogName(this.idx, null);
                    break;
                }
                this.md.setCatalogName(this.idx, s);
                break;
            }
            case 17: {
                if (!(nullValue == 0)) {
                    throw new SQLException(this.resBundle.handleGetObject("xmlrch.badvalue1").toString());
                }
                this.md.setColumnType(this.idx, this.getIntegerValue(s));
                break;
            }
            case 18: {
                if (!(nullValue == 0)) {
                    this.md.setColumnTypeName(this.idx, null);
                    break;
                }
                this.md.setColumnTypeName(this.idx, s);
                break;
            }
        }
    }
    
    private void setDataValue(char[] array, int n, int n2) throws SQLException {
        switch (this.getTag()) {
            case 1: {
                this.columnValue = new String(array, n, n2);
                this.tempStr = this.tempStr.concat(this.columnValue);
                break;
            }
            case 5: {
                this.upd = new Object[2];
                this.tempUpdate = this.tempUpdate.concat(new String(array, n, n2));
                this.upd[0] = Integer.valueOf(this.idx);
                this.upd[1] = this.tempUpdate;
                this.lastval = (String)this.upd[1];
                break;
            }
        }
    }
    
    private void insertValue(String s) throws SQLException {
        if (this.getNullValue()) {
            this.rs.updateNull(this.idx);
            return;
        }
        switch (this.rs.getMetaData().getColumnType(this.idx)) {
            case -7: {
                this.rs.updateBoolean(this.idx, this.getBooleanValue(s));
                break;
            }
            case 16: {
                this.rs.updateBoolean(this.idx, this.getBooleanValue(s));
                break;
            }
            case -6:
            case 5: {
                this.rs.updateShort(this.idx, this.getShortValue(s));
                break;
            }
            case 4: {
                this.rs.updateInt(this.idx, this.getIntegerValue(s));
                break;
            }
            case -5: {
                this.rs.updateLong(this.idx, this.getLongValue(s));
                break;
            }
            case 6:
            case 7: {
                this.rs.updateFloat(this.idx, this.getFloatValue(s));
                break;
            }
            case 8: {
                this.rs.updateDouble(this.idx, this.getDoubleValue(s));
                break;
            }
            case 2:
            case 3: {
                this.rs.updateObject(this.idx, this.getBigDecimalValue(s));
                break;
            }
            case -4:
            case -3:
            case -2: {
                this.rs.updateBytes(this.idx, this.getBinaryValue(s));
                break;
            }
            case 91: {
                this.rs.updateDate(this.idx, this.getDateValue(s));
                break;
            }
            case 92: {
                this.rs.updateTime(this.idx, this.getTimeValue(s));
                break;
            }
            case 93: {
                this.rs.updateTimestamp(this.idx, this.getTimestampValue(s));
                break;
            }
            case -1:
            case 1:
            case 12: {
                this.rs.updateString(this.idx, this.getStringValue(s));
                break;
            }
        }
        return;
    }
    
    @Override
    public void error(SAXParseException ex) throws SAXParseException {
        throw ex;
    }
    
    @Override
    public void warning(SAXParseException ex) throws SAXParseException {
        System.out.println(MessageFormat.format(this.resBundle.handleGetObject("xmlrch.warning").toString(), new Object[] { ex.getMessage(), Integer.valueOf(ex.getLineNumber()), ex.getSystemId() }));
    }
    
    @Override
    public void notationDecl(String s, String s2, String s3) {
    }
    
    @Override
    public void unparsedEntityDecl(String s, String s2, String s3, String s4) {
    }
    
    private Row getPresentRow(WebRowSetImpl webRowSetImpl) throws SQLException {
        return null;
    }
}
